//+------------------------------------------------------------------+
//|                                                   i-3SAR-Sig.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|   11.06.2005      .            |
//|      ,    -  .|
//|  -    .    |
//|    .                                  |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LightBlue
#property indicator_color2 Salmon

//-------    -------------------------------
extern double StepSAR      = 0.02;    //   
extern double MaxSAR       = 0.2;     //   
extern int    PeriodSAR1   = 60;      //    
extern double StepSAR1     = 0.02;    //    
extern double MaxSAR1      = 0.2;     //    
extern int    PeriodSAR2   = 240;     //    
extern double StepSAR2     = 0.02;    //    
extern double MaxSAR2      = 0.2;     //    

//-------   --------------------------------------
int ArrowInterval;

double ms[2];
int nExtCountedBars = 0;

//-------   ------------------------------------------
double SigBuy[];
double SigSell[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  SetIndexBuffer(0, SigBuy);
  SetIndexStyle (0, DRAW_ARROW);
  SetIndexArrow (0, 233);
  SetIndexEmptyValue(0, 0);

  SetIndexBuffer(1, SigSell);
  SetIndexStyle (1, DRAW_ARROW);
  SetIndexArrow (1, 234);
  SetIndexEmptyValue(1, 0);

  ArrowInterval=GetArrowInterval();
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() 
{
	if(Bars <= 240) 
		return(0);
		
	nExtCountedBars = IndicatorCounted();
	if(nExtCountedBars < 0) 
		return(-1);

	// last counted bar will be recounted
	if(nExtCountedBars > 0) 
		nExtCountedBars--;

	int nPos = Bars - nExtCountedBars;

	while(nPos > 0)
	{
		ms[0]=0;
		ms[1]=0;

		GetSignals(nPos, ms);
		SigBuy[nPos] = ms[0];
		SigSell[nPos] = ms[1];

		nPos--;
	}
}

//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
void GetSignals(int nb, double& ms[]) 
{
  double tsar0=iSAR(NULL, 0, StepSAR, MaxSAR, nb);
  double tsar1=iSAR(NULL, 0, StepSAR, MaxSAR, nb+1);
  int nb1=iBarShift(NULL, PeriodSAR1, Time[nb]);
  double sar1=iSAR(NULL, PeriodSAR1, StepSAR1, MaxSAR1, nb1);
  int nb2=iBarShift(NULL, PeriodSAR2, Time[nb]);
  double sar2=iSAR(NULL, PeriodSAR2, StepSAR2, MaxSAR2, nb2);

  if (tsar1>Close[nb+1] && tsar0<Close[nb] && sar1<Close[nb] && sar2<Close[nb])
    ms[0]=Low[nb]-ArrowInterval*Point;
  if (tsar1<Close[nb+1] && tsar0>Close[nb] && sar1>Close[nb] && sar2>Close[nb])
    ms[1]=High[nb]+ArrowInterval*Point;
}

//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
int GetArrowInterval() {
  int p=Period();

  switch (p) {
    case 1:     return(3);
    case 5:     return(5);
    case 15:    return(8);
    case 30:    return(12);
    case 60:    return(17);
    case 240:   return(25);
    case 1440:  return(50);
    case 10080: return(100);
    case 43200: return(200);
  }
}
//+------------------------------------------------------------------+

